Index: trunk/SophyaExt/FitsIOServer/Makefile
===================================================================
--- trunk/SophyaExt/FitsIOServer/Makefile	(revision 1836)
+++ trunk/SophyaExt/FitsIOServer/Makefile	(revision 1837)
@@ -6,5 +6,5 @@
 	rm -f $(LIB)libFitsIOServer.a
 $(LIB)libFitsIOServer.a : $(OBJ)datacirclefits.o $(OBJ)fabtcolread.o $(OBJ)fabtwriter.o $(OBJ)fboloread.o $(OBJ)fbtntintf.o $(OBJ)fitsautoreader.o $(OBJ)fitsbntbllineRW.o $(OBJ)fitsfile.o $(OBJ)fitslocalmap.o $(OBJ)fitsntuple.o $(OBJ)fitsspherehealpix.o $(OBJ)fitstarray.o $(OBJ)fitsxntuple.o
-	$(ARCXX) $(ARCXXFLAGS) $@ $?
+	$(ARCXX) $(ARCXXFLAGS) $@ $($(ARARGS))
 ifeq ($(CXX),cxx)
 	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -o $(OBJ)xx.x -Hf
@@ -19,13 +19,5 @@
  $(INC)utilgeom.h \
  $(INC)unitvector.h \
- $(INC)geometry.h fitsfile.h \
- $(INC)ndatablock.h \
- $(INC)anydataobj.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ppersist.h \
- $(INC)pexceptions.h \
- $(INC)gnumd5.h \
- $(INC)mutyv.h \
+ $(INC)geometry.h \
  $(EXTINCPATH)FitsIO/fitsio.h \
  $(EXTINCPATH)FitsIO/longnam.h
Index: trunk/SophyaExt/IFFTW/Makefile
===================================================================
--- trunk/SophyaExt/IFFTW/Makefile	(revision 1836)
+++ trunk/SophyaExt/IFFTW/Makefile	(revision 1837)
@@ -6,5 +6,5 @@
 	rm -f $(LIB)libIFFTW.a
 $(LIB)libIFFTW.a : $(OBJ)fftwserver.o
-	$(ARCXX) $(ARCXXFLAGS) $@ $?
+	$(ARCXX) $(ARCXXFLAGS) $@ $($(ARARGS))
 ifeq ($(CXX),cxx)
 	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -o $(OBJ)xx.x -Hf
Index: trunk/SophyaExt/LinAlg/Makefile
===================================================================
--- trunk/SophyaExt/LinAlg/Makefile	(revision 1836)
+++ trunk/SophyaExt/LinAlg/Makefile	(revision 1837)
@@ -6,5 +6,5 @@
 	rm -f $(LIB)libLinAlg.a
 $(LIB)libLinAlg.a : $(OBJ)intflapack.o
-	$(ARCXX) $(ARCXXFLAGS) $@ $?
+	$(ARCXX) $(ARCXXFLAGS) $@ $($(ARARGS))
 ifeq ($(CXX),cxx)
 	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -o $(OBJ)xx.x -Hf
Index: trunk/SophyaExt/XAstroPack/Makefile
===================================================================
--- trunk/SophyaExt/XAstroPack/Makefile	(revision 1836)
+++ trunk/SophyaExt/XAstroPack/Makefile	(revision 1837)
@@ -13,6 +13,6 @@
 $(OBJ)mollweide.o: mollweide.cc mollweide.h
 $(OBJ)xastropack.o: xastropack.cc xastropack.h \
-  $(INC)machdefs.h \
-  $(EXTINCPATH)XAstro/P_.h \
-  $(EXTINCPATH)XAstro/astro.h
+ $(INC)machdefs.h \
+ $(EXTINCPATH)XAstro/P_.h \
+ $(EXTINCPATH)XAstro/astro.h
 $(OBJ)magfield.o: magfield.c magfield.h
Index: trunk/SophyaLib/BaseTools/Makefile
===================================================================
--- trunk/SophyaLib/BaseTools/Makefile	(revision 1836)
+++ trunk/SophyaLib/BaseTools/Makefile	(revision 1837)
@@ -6,5 +6,5 @@
 	rm -f $(LIB)libBaseTools.a
 $(LIB)libBaseTools.a : $(OBJ)datatype.o $(OBJ)dvlist.o $(OBJ)fiondblock.o $(OBJ)gnumd5.o $(OBJ)mutyv.o $(OBJ)ndatablock.o $(OBJ)pexceptions.o $(OBJ)ppersist.o $(OBJ)sophyainit.o $(OBJ)srandgen.o
-	$(ARCXX) $(ARCXXFLAGS) $@ $?
+	$(ARCXX) $(ARCXXFLAGS) $@ $($(ARARGS))
 ifeq ($(CXX),cxx)
 	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -o $(OBJ)xx.x -Hf
Index: trunk/SophyaLib/BaseTools/sversion.h
===================================================================
--- trunk/SophyaLib/BaseTools/sversion.h	(revision 1836)
+++ trunk/SophyaLib/BaseTools/sversion.h	(revision 1837)
@@ -3,6 +3,6 @@
 
 #define SOPHYA_VERSION   1.3
-#define SOPHYA_REVISION  30 
-#define SOPHYA_TAG       "V_Nov2001"
+#define SOPHYA_REVISION  50 
+#define SOPHYA_TAG       "V_Dec2001"
 
 #endif
Index: trunk/SophyaLib/HiStats/Makefile
===================================================================
--- trunk/SophyaLib/HiStats/Makefile	(revision 1836)
+++ trunk/SophyaLib/HiStats/Makefile	(revision 1837)
@@ -6,5 +6,5 @@
 	rm -f $(LIB)libHiStats.a
 $(LIB)libHiStats.a : $(OBJ)hisprof.o $(OBJ)histinit.o $(OBJ)histos.o $(OBJ)histos2.o $(OBJ)ntupintf.o $(OBJ)ntuple.o $(OBJ)xntuple.o
-	$(ARCXX) $(ARCXXFLAGS) $@ $?
+	$(ARCXX) $(ARCXXFLAGS) $@ $($(ARARGS))
 ifeq ($(CXX),cxx)
 	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -o $(OBJ)xx.x -Hf
Index: trunk/SophyaLib/Mgr/Makefile
===================================================================
--- trunk/SophyaLib/Mgr/Makefile	(revision 1836)
+++ trunk/SophyaLib/Mgr/Makefile	(revision 1837)
@@ -94,4 +94,5 @@
 PI:
 	if [ -d PI ] ; then cd PI ; $(MAKE) ; fi
+	if [ -d PIGcont ] ; then cd PIGcont ; $(MAKE) ; fi
 	if [ -d PIext ] ; then cd PIext ; $(MAKE) ; fi
 #  Shared library creation part of the Makefile
@@ -159,6 +160,7 @@
 # List of .o files for PI modules 
 OBJPI = $(shell echo `cat ./PI/objlist.list `)
+OBJPIGcont = $(shell echo `cat ./PIGcont/objlist.list `)
 OBJPIext = $(shell echo `cat ./PIext/objlist.list `)
-ALLPIOBJS = $(OBJPI) $(OBJPIext)
+ALLPIOBJS = $(OBJPI) $(OBJPIGcont) $(OBJPIext) 
  
 # Building Sophya shared library
Index: trunk/SophyaLib/NTools/Makefile
===================================================================
--- trunk/SophyaLib/NTools/Makefile	(revision 1836)
+++ trunk/SophyaLib/NTools/Makefile	(revision 1837)
@@ -6,5 +6,5 @@
 	rm -f $(LIB)libNTools.a
 $(LIB)libNTools.a : $(OBJ)cimage.o $(OBJ)cspline.o $(OBJ)datatypes.o $(OBJ)dates.o $(OBJ)datime.o $(OBJ)difeq.o $(OBJ)dynccd.o $(OBJ)fct1dfit.o $(OBJ)fct2dfit.o $(OBJ)fftmayer_r4.o $(OBJ)fftmayer_r8.o $(OBJ)fftmserver.o $(OBJ)fftpackc.o $(OBJ)fftpserver.o $(OBJ)fftservintf.o $(OBJ)generaldata.o $(OBJ)generalfit.o $(OBJ)integ.o $(OBJ)matxop.o $(OBJ)median.o $(OBJ)nbmath.o $(OBJ)nbtri.o $(OBJ)ntoolsinit.o $(OBJ)objfitter.o $(OBJ)perandom.o $(OBJ)poly.o $(OBJ)rk4cdifeq.o $(OBJ)simplesort.o $(OBJ)tabmath.o
-	$(ARCXX) $(ARCXXFLAGS) $@ $?
+	$(ARCXX) $(ARCXXFLAGS) $@ $($(ARARGS))
 ifeq ($(CXX),cxx)
 	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -o $(OBJ)xx.x -Hf
Index: trunk/SophyaLib/SUtils/Makefile
===================================================================
--- trunk/SophyaLib/SUtils/Makefile	(revision 1836)
+++ trunk/SophyaLib/SUtils/Makefile	(revision 1837)
@@ -6,5 +6,5 @@
 	rm -f $(LIB)libSUtils.a
 $(LIB)libSUtils.a : $(OBJ)datacards.o $(OBJ)strutil.o $(OBJ)strutilxx.o $(OBJ)utils.o
-	$(ARCXX) $(ARCXXFLAGS) $@ $?
+	$(ARCXX) $(ARCXXFLAGS) $@ $($(ARARGS))
 ifeq ($(CXX),cxx)
 	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -o $(OBJ)xx.x -Hf
Index: trunk/SophyaLib/Samba/Makefile
===================================================================
--- trunk/SophyaLib/Samba/Makefile	(revision 1836)
+++ trunk/SophyaLib/Samba/Makefile	(revision 1837)
@@ -6,5 +6,5 @@
 	rm -f $(LIB)libSamba.a
 $(LIB)libSamba.a : $(OBJ)alm.o $(OBJ)bruit.o $(OBJ)circle.o $(OBJ)datacirclefake.o $(OBJ)lambdaBuilder.o $(OBJ)mlobe.o $(OBJ)sambainit.o $(OBJ)scan.o $(OBJ)sphericaltransformserver.o
-	$(ARCXX) $(ARCXXFLAGS) $@ $?
+	$(ARCXX) $(ARCXXFLAGS) $@ $($(ARARGS))
 ifeq ($(CXX),cxx)
 	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -o $(OBJ)xx.x -Hf
Index: trunk/SophyaLib/SkyMap/Makefile
===================================================================
--- trunk/SophyaLib/SkyMap/Makefile	(revision 1836)
+++ trunk/SophyaLib/SkyMap/Makefile	(revision 1837)
@@ -6,5 +6,5 @@
 	rm -f $(LIB)libSkyMap.a
 $(LIB)libSkyMap.a : $(OBJ)HEALPixUtils.o $(OBJ)fiolocalmap.o $(OBJ)fiospherehealpix.o $(OBJ)fiospherethetaphi.o $(OBJ)localmap.o $(OBJ)longlat.o $(OBJ)mapoperation.o $(OBJ)skymapinit.o $(OBJ)spherehealpix.o $(OBJ)spherepos.o $(OBJ)spherethetaphi.o $(OBJ)unitvector.o $(OBJ)utilgeom.o $(OBJ)vector3d.o
-	$(ARCXX) $(ARCXXFLAGS) $@ $?
+	$(ARCXX) $(ARCXXFLAGS) $@ $($(ARARGS))
 ifeq ($(CXX),cxx)
 	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -o $(OBJ)xx.x -Hf
Index: trunk/SophyaLib/SkyT/Makefile
===================================================================
--- trunk/SophyaLib/SkyT/Makefile	(revision 1836)
+++ trunk/SophyaLib/SkyT/Makefile	(revision 1837)
@@ -6,5 +6,5 @@
 	rm -f $(LIB)libSkyT.a
 $(LIB)libSkyT.a : $(OBJ)blackbody.o $(OBJ)convtools.o $(OBJ)derivblackbody.o $(OBJ)gaussfilt.o $(OBJ)nupower.o $(OBJ)radspec.o $(OBJ)radspecvector.o $(OBJ)skyinit.o $(OBJ)specresp.o $(OBJ)specrespvector.o $(OBJ)squarefilt.o $(OBJ)trianglefilt.o
-	$(ARCXX) $(ARCXXFLAGS) $@ $?
+	$(ARCXX) $(ARCXXFLAGS) $@ $($(ARARGS))
 ifeq ($(CXX),cxx)
 	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -o $(OBJ)xx.x -Hf
Index: trunk/SophyaLib/SysTools/Makefile
===================================================================
--- trunk/SophyaLib/SysTools/Makefile	(revision 1836)
+++ trunk/SophyaLib/SysTools/Makefile	(revision 1837)
@@ -6,5 +6,5 @@
 	rm -f $(LIB)libSysTools.a
 $(LIB)libSysTools.a : $(OBJ)ctimer.o $(OBJ)cxxcmplnk.o $(OBJ)pdlmgr.o $(OBJ)periodic.o $(OBJ)psighand.o $(OBJ)timing.o $(OBJ)zthread.o
-	$(ARCXX) $(ARCXXFLAGS) $@ $?
+	$(ARCXX) $(ARCXXFLAGS) $@ $($(ARARGS))
 ifeq ($(CXX),cxx)
 	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -o $(OBJ)xx.x -Hf
@@ -14,5 +14,5 @@
 $(OBJ)cxxcmplnk.o: cxxcmplnk.cc cxxcmplnk.h \
  $(INC)machdefs.h
-$(OBJ)pdlmgr.o: pdlmgr.cc pdlmgr.h $(INC)machdefs.h
+$(OBJ)pdlmgr.o: pdlmgr.cc pdlmgr.h
 $(OBJ)periodic.o: periodic.cc $(INC)machdefs.h \
  periodic.h
Index: trunk/SophyaLib/TArray/Makefile
===================================================================
--- trunk/SophyaLib/TArray/Makefile	(revision 1836)
+++ trunk/SophyaLib/TArray/Makefile	(revision 1837)
@@ -6,5 +6,5 @@
 	rm -f $(LIB)libTArray.a
 $(LIB)libTArray.a : $(OBJ)basarr.o $(OBJ)fioarr.o $(OBJ)matharr.o $(OBJ)sopemtx.o $(OBJ)tarray.o $(OBJ)tarrinit.o $(OBJ)tmatrix.o $(OBJ)tvector.o $(OBJ)utilarr.o
-	$(ARCXX) $(ARCXXFLAGS) $@ $?
+	$(ARCXX) $(ARCXXFLAGS) $@ $($(ARARGS))
 ifeq ($(CXX),cxx)
 	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -o $(OBJ)xx.x -Hf
Index: trunk/SophyaPI/PI/Makefile
===================================================================
--- trunk/SophyaPI/PI/Makefile	(revision 1836)
+++ trunk/SophyaPI/PI/Makefile	(revision 1837)
@@ -5,5 +5,5 @@
 all: $(LIB)libPI.a
 $(LIB)libPI.a : $(OBJ)lut.o $(OBJ)parradapter.o $(OBJ)pi3ddrw.o $(OBJ)piapplgen.o $(OBJ)piapplx.o $(OBJ)piaxestools.o $(OBJ)pibwdggen.o $(OBJ)pibwdgx.o $(OBJ)picmap.o $(OBJ)picmapgen.o $(OBJ)picmapview.o $(OBJ)picmapx.o $(OBJ)picons.o $(OBJ)picontainergen.o $(OBJ)picontainerx.o $(OBJ)pidrawer.o $(OBJ)pidrawwin.o $(OBJ)pidrwtools.o $(OBJ)pievthandler.o $(OBJ)pifilechogen.o $(OBJ)pifilechox.o $(OBJ)pifontgen.o $(OBJ)pifontx.o $(OBJ)pigraph3d.o $(OBJ)pigraphgen.o $(OBJ)pigraphps.o $(OBJ)pigraphuc.o $(OBJ)pigraphx.o $(OBJ)piimage.o $(OBJ)piimgtools.o $(OBJ)pilistgen.o $(OBJ)pilistx.o $(OBJ)pimenubargen.o $(OBJ)pimenubarx.o $(OBJ)pimenugen.o $(OBJ)pimenux.o $(OBJ)pimsghandler.o $(OBJ)pioptmenugen.o $(OBJ)pioptmenux.o $(OBJ)piperiodx.o $(OBJ)pipixmapgen.o $(OBJ)pipixmapx.o $(OBJ)piscdrawwdg.o $(OBJ)pistdwdggen.o $(OBJ)pistdwdgx.o $(OBJ)pistzwin.o $(OBJ)pisurfdr.o $(OBJ)pitherm.o $(OBJ)piwdggen.o $(OBJ)piwdgx.o $(OBJ)piwindowgen.o $(OBJ)piwindowx.o $(OBJ)pixtbase.o $(OBJ)psfile.o
-	$(AR) $(ARFLAGS)  $@ $? 
+	$(AR) $(ARFLAGS)  $@ $($(ARARGS)) 
 ifeq ($(CXX),cxx)
 	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -o $(OBJ)xx.x -Hf
@@ -90,5 +90,9 @@
  pidrawer.h pibwdggen.h pisysdep.h piwdgx.h piwdggen.h pimsghandler.h \
  picolist.h picmap.h picmapx.h picmapgen.h pigraphx.h pigraphgen.h \
- pifontx.h pifontgen.h pigraphuc.h pievthandler.h psfile.h
+ pifontx.h pifontgen.h pigraphuc.h pievthandler.h psfile.h \
+ pidrwtools.h pistdwdgx.h pistdwdggen.h pioptmenux.h pioptmenugen.h \
+ pimenux.h pimenugen.h piwindowx.h piwindowgen.h picontainerx.h \
+ picontainergen.h piapplx.h piapplgen.h pimenubarx.h pimenubargen.h \
+ picons.h pibwdgx.h pigraphps.h
 $(OBJ)pidrawwin.o: pidrawwin.cc pidrawwin.h pisysdep.h \
  $(INC)machdefs.h piwindowx.h piwindowgen.h \
Index: trunk/SophyaPI/PIGcont/Makefile
===================================================================
--- trunk/SophyaPI/PIGcont/Makefile	(revision 1836)
+++ trunk/SophyaPI/PIGcont/Makefile	(revision 1837)
@@ -5,5 +5,5 @@
 all: $(LIB)libPIGcont.a
 $(LIB)libPIGcont.a : $(OBJ)contour.o $(OBJ)myalloc.o $(OBJ)myaxis.o $(OBJ)picntools.o $(OBJ)pigncont.o $(OBJ)set.o
-	$(AR) $(ARFLAGS)  $@ $? 
+	$(AR) $(ARFLAGS)  $@ $($(ARARGS)) 
 ifeq ($(CXX),cxx)
 	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -o $(OBJ)xx.x -Hf
Index: trunk/SophyaPI/PIext/Makefile
===================================================================
--- trunk/SophyaPI/PIext/Makefile	(revision 1836)
+++ trunk/SophyaPI/PIext/Makefile	(revision 1837)
@@ -4,6 +4,6 @@
  
 all: $(LIB)libPIext.a
-$(LIB)libPIext.a : $(OBJ)basexecut.o $(OBJ)cxxexecutor.o $(OBJ)cxxexecwin.o $(OBJ)nobjmgr.o $(OBJ)nomgadapter.o $(OBJ)nomgfdadapter.o $(OBJ)nomhistadapter.o $(OBJ)nomimagadapter.o $(OBJ)nomskymapadapter.o $(OBJ)nomspecrespadapter.o $(OBJ)nomtarradapter.o $(OBJ)nomtmatvecadapter.o $(OBJ)pawexecut.o $(OBJ)piacmd.o $(OBJ)piafitting.o $(OBJ)pigfd1.o $(OBJ)pigfd2.o $(OBJ)pihisto.o $(OBJ)pihisto2d.o $(OBJ)piinit.o $(OBJ)pintup3d.o $(OBJ)pintuple.o $(OBJ)pipodrw.o $(OBJ)pisiadw.o $(OBJ)pistdimgapp.o $(OBJ)pitvmaad.o $(OBJ)servnobjm.o
-	$(AR) $(ARFLAGS)  $@ $? 
+$(LIB)libPIext.a : $(OBJ)basexecut.o $(OBJ)contmodex.o $(OBJ)cxxexecutor.o $(OBJ)cxxexecwin.o $(OBJ)nobjmgr.o $(OBJ)nomgadapter.o $(OBJ)nomgfdadapter.o $(OBJ)nomhistadapter.o $(OBJ)nomimagadapter.o $(OBJ)nomskymapadapter.o $(OBJ)nomspecrespadapter.o $(OBJ)nomtarradapter.o $(OBJ)nomtmatvecadapter.o $(OBJ)pawexecut.o $(OBJ)piacmd.o $(OBJ)piafitting.o $(OBJ)pigfd1.o $(OBJ)pigfd2.o $(OBJ)pihisto.o $(OBJ)pihisto2d.o $(OBJ)piinit.o $(OBJ)pintup3d.o $(OBJ)pintuple.o $(OBJ)pipodrw.o $(OBJ)pisiadw.o $(OBJ)pistdimgapp.o $(OBJ)pitvmaad.o $(OBJ)servnobjm.o
+	$(AR) $(ARFLAGS)  $@ $($(ARARGS)) 
 ifeq ($(CXX),cxx)
 	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -o $(OBJ)xx.x -Hf
@@ -11,5 +11,5 @@
  
 clean:
-	rm -f $(OBJ)basexecut.o $(OBJ)cxxexecutor.o $(OBJ)cxxexecwin.o $(OBJ)nobjmgr.o $(OBJ)nomgadapter.o $(OBJ)nomgfdadapter.o $(OBJ)nomhistadapter.o $(OBJ)nomimagadapter.o $(OBJ)nomskymapadapter.o $(OBJ)nomspecrespadapter.o $(OBJ)nomtarradapter.o $(OBJ)nomtmatvecadapter.o $(OBJ)pawexecut.o $(OBJ)piacmd.o $(OBJ)piafitting.o $(OBJ)pigfd1.o $(OBJ)pigfd2.o $(OBJ)pihisto.o $(OBJ)pihisto2d.o $(OBJ)piinit.o $(OBJ)pintup3d.o $(OBJ)pintuple.o $(OBJ)pipodrw.o $(OBJ)pisiadw.o $(OBJ)pistdimgapp.o $(OBJ)pitvmaad.o $(OBJ)servnobjm.o
+	rm -f $(OBJ)basexecut.o $(OBJ)contmodex.o $(OBJ)cxxexecutor.o $(OBJ)cxxexecwin.o $(OBJ)nobjmgr.o $(OBJ)nomgadapter.o $(OBJ)nomgfdadapter.o $(OBJ)nomhistadapter.o $(OBJ)nomimagadapter.o $(OBJ)nomskymapadapter.o $(OBJ)nomspecrespadapter.o $(OBJ)nomtarradapter.o $(OBJ)nomtmatvecadapter.o $(OBJ)pawexecut.o $(OBJ)piacmd.o $(OBJ)piafitting.o $(OBJ)pigfd1.o $(OBJ)pigfd2.o $(OBJ)pihisto.o $(OBJ)pihisto2d.o $(OBJ)piinit.o $(OBJ)pintup3d.o $(OBJ)pintuple.o $(OBJ)pipodrw.o $(OBJ)pisiadw.o $(OBJ)pistdimgapp.o $(OBJ)pitvmaad.o $(OBJ)servnobjm.o
 ifeq ($(CXX),cxx)
 	cd $(REPM); rm -f *.o
@@ -93,4 +93,87 @@
  $(INC)generaldata.h \
  $(INC)poly.h
+$(OBJ)contmodex.o: contmodex.cc contmodex.h \
+ $(INC)machdefs.h piacmd.h dlftypes.h \
+ $(INC)pdlmgr.h nobjmgr.h \
+ $(INC)anydataobj.h \
+ $(INC)ppersist.h \
+ $(INC)pexceptions.h \
+ $(INC)gnumd5.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)mutyv.h \
+ $(INC)pigncont.h \
+ $(INC)pistdimgapp.h \
+ $(INC)pisysdep.h \
+ $(INC)piapplx.h \
+ $(INC)piapplgen.h \
+ $(INC)pimsghandler.h \
+ $(INC)picontainerx.h \
+ $(INC)picontainergen.h \
+ $(INC)piwdgx.h \
+ $(INC)piwdggen.h \
+ $(INC)picolist.h \
+ $(INC)pimenubarx.h \
+ $(INC)pimenubargen.h \
+ $(INC)pimenux.h \
+ $(INC)pimenugen.h \
+ $(INC)picons.h \
+ $(INC)pistdwdgx.h \
+ $(INC)pistdwdggen.h \
+ $(INC)pibwdgx.h \
+ $(INC)pibwdggen.h \
+ $(INC)picmap.h \
+ $(INC)picmapx.h \
+ $(INC)picmapgen.h \
+ $(INC)pigraphx.h \
+ $(INC)pigraphgen.h \
+ $(INC)pifontx.h \
+ $(INC)pifontgen.h \
+ $(INC)pigraphuc.h \
+ $(INC)pievthandler.h \
+ $(INC)psfile.h \
+ $(INC)pigraphps.h \
+ $(INC)piwindowx.h \
+ $(INC)piwindowgen.h \
+ $(INC)pioptmenux.h \
+ $(INC)pioptmenugen.h \
+ $(INC)pifilechox.h \
+ $(INC)pifilechogen.h \
+ $(INC)piimage.h \
+ $(INC)parradapter.h \
+ $(INC)lut.h \
+ $(INC)pidrawer.h \
+ $(INC)pipixmapx.h \
+ $(INC)pipixmapgen.h \
+ $(INC)picmapview.h \
+ $(INC)pi3ddrw.h \
+ $(INC)pigraph3d.h \
+ $(INC)nobjmgr.h \
+ $(INC)piacmd.h \
+ $(INC)pisiadw.h \
+ $(INC)pilistx.h \
+ $(INC)pilistgen.h \
+ $(INC)pistzwin.h \
+ $(INC)piperiodx.h \
+ $(INC)periodic.h \
+ $(INC)piscdrawwdg.h \
+ $(INC)ntuple.h \
+ $(INC)ntupintf.h \
+ $(INC)contour.h \
+ $(INC)dynarray.h \
+ $(INC)set.h nomgadapter.h \
+ $(INC)generalfit.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h \
+ $(INC)generaldata.h \
+ $(INC)poly.h \
+ $(INC)peida.h \
+ $(INC)utils.h \
+ $(INC)perrors.h \
+ $(INC)fmath.h servnobjm.h
 $(OBJ)cxxexecutor.o: cxxexecutor.cc cxxexecutor.h \
  $(INC)machdefs.h piacmd.h dlftypes.h \
@@ -921,5 +1004,5 @@
  $(INC)perrors.h \
  $(INC)fmath.h pawexecut.h cxxexecutor.h \
- cxxexecwin.h
+ cxxexecwin.h contmodex.h
 $(OBJ)piafitting.o: piafitting.cc $(INC)strutil.h \
  $(INC)nbtri.h \
@@ -1513,5 +1596,6 @@
  $(INC)piscdrawwdg.h \
  $(INC)piimgtools.h \
- $(INC)pidrwtools.h piinit.h \
+ $(INC)pidrwtools.h \
+ $(INC)piaxestools.h piinit.h \
  $(INC)sambainit.h \
  $(INC)skymapinit.h \
Index: trunk/SophyaPI/PIext/objlist.list
===================================================================
--- trunk/SophyaPI/PIext/objlist.list	(revision 1836)
+++ trunk/SophyaPI/PIext/objlist.list	(revision 1837)
@@ -1,3 +1,4 @@
 basexecut.o
+contmodex.o
 cxxexecutor.o
 cxxexecwin.o