Index: trunk/SophyaPI/PIGcont/Makefile
===================================================================
--- trunk/SophyaPI/PIGcont/Makefile	(revision 1837)
+++ trunk/SophyaPI/PIGcont/Makefile	(revision 1838)
@@ -17,6 +17,6 @@
  
 $(OBJ)contour.o: contour.c contour.h gp_types.h mymisc.h dynarray.h \
- graph3d.h alloc.h myaxis.h
-$(OBJ)myalloc.o: myalloc.c alloc.h graph3d.h gp_types.h mymisc.h
+ graph3d.h gp_alloc.h myaxis.h
+$(OBJ)myalloc.o: myalloc.c gp_alloc.h graph3d.h gp_types.h mymisc.h
 $(OBJ)myaxis.o: myaxis.c myaxis.h mymisc.h
 $(OBJ)picntools.o: picntools.cc picntools.h \
@@ -87,5 +87,5 @@
  $(INC)ntuple.h \
  $(INC)ntupintf.h contour.h gp_types.h \
- dynarray.h mymisc.h graph3d.h alloc.h set.h
+ dynarray.h mymisc.h graph3d.h gp_alloc.h set.h
 $(OBJ)pigncont.o: pigncont.cc $(INC)machdefs.h \
  $(INC)ctimer.h \
@@ -173,4 +173,4 @@
  $(INC)servnobjm.h picntools.h pigncont.h \
  $(INC)piscdrawwdg.h contour.h gp_types.h \
- dynarray.h mymisc.h graph3d.h alloc.h set.h
+ dynarray.h mymisc.h graph3d.h gp_alloc.h set.h
 $(OBJ)set.o: set.c set.h contour.h gp_types.h mymisc.h dynarray.h graph3d.h
Index: trunk/SophyaPI/PIGcont/alloc.h
===================================================================
--- trunk/SophyaPI/PIGcont/alloc.h	(revision 1837)
+++ 	(revision )
@@ -1,92 +1,0 @@
-/*
- * $Id: alloc.h,v 1.1.1.1 2001-12-19 18:01:18 perderos Exp $
- */
-
-/* GNUPLOT - alloc.h */
-
-/*[
- * Copyright 1986 - 1993, 1998   Thomas Williams, Colin Kelley
- *
- * Permission to use, copy, and distribute this software and its
- * documentation for any purpose with or without fee is hereby granted,
- * provided that the above copyright notice appear in all copies and
- * that both that copyright notice and this permission notice appear
- * in supporting documentation.
- *
- * Permission to modify the software is granted, but not the right to
- * distribute the complete modified source code.  Modifications are to
- * be distributed as patches to the released version.  Permission to
- * distribute binaries produced by compiling modified sources is granted,
- * provided you
- *   1. distribute the corresponding source modifications from the
- *    released version in the form of a patch file along with the binaries,
- *   2. add special version identification to distinguish your version
- *    in addition to the base release version number,
- *   3. provide your name and address as the primary contact for the
- *    support of your modified version, and
- *   4. retain our contact information in regard to use of the base
- *    software.
- * Permission to distribute the released version of the source code along
- * with corresponding source modifications in the form of a patch file is
- * granted with same provisions 2 through 4 for binary distributions.
- *
- * This software is provided "as is" without express or implied warranty
- * to the extent permitted by applicable law.
-]*/
-
-#ifndef GNUPLOT_ALLOC_H
-# define GNUPLOT_ALLOC_H
-
-#include <stdio.h>
-#include <stdlib.h>
-#include "graph3d.h"
-/****
-#ifdef HAVE_CONFIG_H
-# include "config.h"
-#endif
-
-#include "stdfn.h"
-****/
-/* prototypes from "alloc.c". This file figures out if the free hack is needed
- * and redefines free if necessary.
- */
- 
-void *gp_alloc(size_t size, const char *message);
-void *gp_realloc(void *p, size_t size, const char *message);
-struct iso_curve *iso_alloc(int);
-
-void iso_free(struct iso_curve *);
-void gp_free(void *);
-void contour_free(struct gnuplot_contours *ptr);
-/* dont define CHECK_HEAP_USE on a FARALLOC machine ! */
-
-#ifdef CHECK_HEAP_USE
-
-/* all allocated blocks have guards at front and back.
- * CHECK_POINTER checks guards on block, and checks that p is in range
- * START_LEAK_CHECK and END_LEAK_CHECK allow assert that no net memory
- * is allocated within enclosed block
- */
- 
-void checked_free(void *p);
-void check_pointer_in_block(void *block, void *p, int size, char *file, int line);
-void start_leak_check(char *file,int line);
-void end_leak_check(char *file,int line);
-/*# define free(x) checked_free(x)*/
-# define CHECK_POINTER(block, p) check_pointer_in_block(block, p, sizeof(*p), __FILE__, __LINE__)
-# define START_LEAK_CHECK() start_leak_check(__FILE__, __LINE__)
-# define END_LEAK_CHECK() end_leak_check(__FILE__, __LINE__)
-#else
-# define CHECK_POINTER(block, p) /*nowt*/
-# define START_LEAK_CHECK() /*nowt*/
-# define END_LEAK_CHECK() /*nowt*/
-#endif
-
-/***
-#if defined(MSDOS) && defined(__TURBOC__) && !defined(DOSX286) || defined(_Windows) && !defined(WIN32) 
-#define FARALLOC 
-void gpfree((generic *p)); 
-#define free gpfree 
-#endif 
-***/
-#endif /* GNUPLOT_ALLOC_H */
Index: trunk/SophyaPI/PIGcont/contour.c
===================================================================
--- trunk/SophyaPI/PIGcont/contour.c	(revision 1837)
+++ trunk/SophyaPI/PIGcont/contour.c	(revision 1838)
@@ -1,4 +1,4 @@
 #ifndef lint
-static char *RCSid() { return RCSid("$Id: contour.c,v 1.1.1.1 2001-12-19 18:01:18 perderos Exp $"); }
+static char *RCSid() { return RCSid("$Id: contour.c,v 1.2 2001-12-21 22:49:27 ansari Exp $"); }
 #endif
 
@@ -49,5 +49,5 @@
 #include "contour.h"
 
-#include "alloc.h"
+#include "gp_alloc.h"
 #include "myaxis.h"
 /*  #include "setshow.h" */
@@ -73,6 +73,10 @@
 
 
+/* Valeur de zero - Reza 21/12/2001 - Pourquoi zero = 0. ??? */
+static double zero = 0.;
+
 /* FIXME HBB 2000052: yet another local copy of 'epsilon'. Why? */
 #define EPSILON  1e-5		/* Used to decide if two float are equal. */
+
 
 #ifndef TRUE
@@ -80,4 +84,5 @@
 #define FALSE    0
 #endif
+
 
 #define MAX_POINTS_PER_CNTR 	100
Index: trunk/SophyaPI/PIGcont/gp_alloc.h
===================================================================
--- trunk/SophyaPI/PIGcont/gp_alloc.h	(revision 1838)
+++ trunk/SophyaPI/PIGcont/gp_alloc.h	(revision 1838)
@@ -0,0 +1,89 @@
+
+/* GNUPLOT - gp_alloc.h (alloc.h renamed to gp_alloc.h) */
+
+/*[
+ * Copyright 1986 - 1993, 1998   Thomas Williams, Colin Kelley
+ *
+ * Permission to use, copy, and distribute this software and its
+ * documentation for any purpose with or without fee is hereby granted,
+ * provided that the above copyright notice appear in all copies and
+ * that both that copyright notice and this permission notice appear
+ * in supporting documentation.
+ *
+ * Permission to modify the software is granted, but not the right to
+ * distribute the complete modified source code.  Modifications are to
+ * be distributed as patches to the released version.  Permission to
+ * distribute binaries produced by compiling modified sources is granted,
+ * provided you
+ *   1. distribute the corresponding source modifications from the
+ *    released version in the form of a patch file along with the binaries,
+ *   2. add special version identification to distinguish your version
+ *    in addition to the base release version number,
+ *   3. provide your name and address as the primary contact for the
+ *    support of your modified version, and
+ *   4. retain our contact information in regard to use of the base
+ *    software.
+ * Permission to distribute the released version of the source code along
+ * with corresponding source modifications in the form of a patch file is
+ * granted with same provisions 2 through 4 for binary distributions.
+ *
+ * This software is provided "as is" without express or implied warranty
+ * to the extent permitted by applicable law.
+]*/
+
+#ifndef GNUPLOT_ALLOC_H
+# define GNUPLOT_ALLOC_H
+
+#include <stdio.h>
+#include <stdlib.h>
+#include "graph3d.h"
+/****
+#ifdef HAVE_CONFIG_H
+# include "config.h"
+#endif
+
+#include "stdfn.h"
+****/
+/* prototypes from "alloc.c". This file figures out if the free hack is needed
+ * and redefines free if necessary.
+ */
+ 
+void *gp_alloc(size_t size, const char *message);
+void *gp_realloc(void *p, size_t size, const char *message);
+struct iso_curve *iso_alloc(int);
+
+void iso_free(struct iso_curve *);
+void gp_free(void *);
+void contour_free(struct gnuplot_contours *ptr);
+/* dont define CHECK_HEAP_USE on a FARALLOC machine ! */
+
+#ifdef CHECK_HEAP_USE
+
+/* all allocated blocks have guards at front and back.
+ * CHECK_POINTER checks guards on block, and checks that p is in range
+ * START_LEAK_CHECK and END_LEAK_CHECK allow assert that no net memory
+ * is allocated within enclosed block
+ */
+ 
+void checked_free(void *p);
+void check_pointer_in_block(void *block, void *p, int size, char *file, int line);
+void start_leak_check(char *file,int line);
+void end_leak_check(char *file,int line);
+/*# define free(x) checked_free(x)*/
+# define CHECK_POINTER(block, p) check_pointer_in_block(block, p, sizeof(*p), __FILE__, __LINE__)
+# define START_LEAK_CHECK() start_leak_check(__FILE__, __LINE__)
+# define END_LEAK_CHECK() end_leak_check(__FILE__, __LINE__)
+#else
+# define CHECK_POINTER(block, p) /*nowt*/
+# define START_LEAK_CHECK() /*nowt*/
+# define END_LEAK_CHECK() /*nowt*/
+#endif
+
+/***
+#if defined(MSDOS) && defined(__TURBOC__) && !defined(DOSX286) || defined(_Windows) && !defined(WIN32) 
+#define FARALLOC 
+void gpfree((generic *p)); 
+#define free gpfree 
+#endif 
+***/
+#endif /* GNUPLOT_ALLOC_H */
Index: trunk/SophyaPI/PIGcont/myalloc.c
===================================================================
--- trunk/SophyaPI/PIGcont/myalloc.c	(revision 1837)
+++ trunk/SophyaPI/PIGcont/myalloc.c	(revision 1838)
@@ -1,3 +1,3 @@
-#include "alloc.h"
+#include "gp_alloc.h"
 #include "graph3d.h"
 #include <math.h>
Index: trunk/SophyaPI/PIGcont/myaxis.h
===================================================================
--- trunk/SophyaPI/PIGcont/myaxis.h	(revision 1837)
+++ trunk/SophyaPI/PIGcont/myaxis.h	(revision 1838)
@@ -1,4 +1,4 @@
 /* 
- * $Id: myaxis.h,v 1.1.1.1 2001-12-19 18:01:18 perderos Exp $
+ * $Id: myaxis.h,v 1.2 2001-12-21 22:49:27 ansari Exp $
  *
  */
@@ -48,4 +48,8 @@
 
 /* typedefs / #defines */
+#ifndef TRUE
+#define TRUE     -1
+#define FALSE    0
+#endif
 
 /* give some names to some array elements used in command.c and grap*.c
@@ -606,5 +610,5 @@
 /*void axis_set_graphical_range __PROTO((AXIS_INDEX, unsigned int lower, unsigned int upper));*/
 /*TBOOLEAN axis_position_zeroaxis __PROTO((AXIS_INDEX));*/
-/*void axis_draw_2d_zeroaxis __PROTO((AXIS_INDEX, AXIS_INDEX));
+/*void axis_draw_2d_zeroaxis __PROTO((AXIS_INDEX, AXIS_INDEX)); */
 
 /*double get_writeback_min __PROTO((AXIS_INDEX));*/
Index: trunk/SophyaPI/PIGcont/picntools.cc
===================================================================
--- trunk/SophyaPI/PIGcont/picntools.cc	(revision 1837)
+++ trunk/SophyaPI/PIGcont/picntools.cc	(revision 1838)
@@ -3,11 +3,11 @@
 // LAL (Orsay) / IN2P3-CNRS  DAPNIA/SPP (Saclay) / CEA
 
-#include <stdlib.h>
-
+// #include <stdlib.h>
+
+#include "machdefs.h"
+#include <string>
+#include <iostream.h>
 
 #include "picntools.h"
-#include <iostream.h>
-#include "piscdrawwdg.h"
-#include "pi3ddrw.h"
 #include "pigncont.h"
 
Index: trunk/SophyaPI/PIGcont/picntools.h
===================================================================
--- trunk/SophyaPI/PIGcont/picntools.h	(revision 1837)
+++ trunk/SophyaPI/PIGcont/picntools.h	(revision 1838)
@@ -12,10 +12,11 @@
 #include PIWIN_H
 #include PIAPP_H
-#include "pibwdggen.h"
-#include "pigncont.h"
+#include "picmapview.h"
 
 // --------- fenetre de dialogue pour modifs  options de trace des contours  ----------
 // --------------------------------------------------------------------------------
 
+class PIContourDrawer;
+class PIBaseWdgGen;
 
 class PICnTools : public PIWindow 
Index: trunk/SophyaPI/PIGcont/pigncont.cc
===================================================================
--- trunk/SophyaPI/PIGcont/pigncont.cc	(revision 1837)
+++ trunk/SophyaPI/PIGcont/pigncont.cc	(revision 1838)
@@ -5,44 +5,21 @@
 #include <math.h>
 
-#include <typeinfo>
-
-#include <vector>
-#include <string>
-
-#include "ctimer.h"
-#include "piacmd.h"
-#include "nobjmgr.h"
-#include "pistdimgapp.h"
-
-#include "pidrawer.h"
-#include "nomgadapter.h"
-
 #include "histos.h"
-#include "histos2.h"
-#include "hisprof.h"
 #include "ntuple.h"
 
-#include "servnobjm.h"
-#include <nbtri.h> 
+#include "nbtri.h" 
 
 #include "picntools.h"
 #include "pigncont.h"
-//A-Virer #include "pidrwtools.h"
-//A-Virer #include "piaxestools.h"
-
-extern "C" { 
-#include "contour.h"
-#include "alloc.h"
-#include "set.h"
-}
-
-TBOOLEAN multiplot;
-double zero =0;
-TBOOLEAN polar;
-int xleft, xright, ybot, ytop;
-float xsize; 
-float ysize; 
-float xoffset, yoffset;
-
+
+/*  A virer ?? Reza 21/12/2001 
+static TBOOLEAN multiplot;
+static double zero =0;
+static TBOOLEAN fg_polar;
+static int xleft, xright, ybot, ytop;
+static float xsize; 
+static float ysize; 
+static float xoffset, yoffset;
+*/
 
 GNUPlotContour::GNUPlotContour(struct iso_curve * iso){
Index: trunk/SophyaPI/PIGcont/pigncont.h
===================================================================
--- trunk/SophyaPI/PIGcont/pigncont.h	(revision 1837)
+++ trunk/SophyaPI/PIGcont/pigncont.h	(revision 1838)
@@ -14,5 +14,5 @@
 extern "C" { 
 #include "contour.h"
-#include "alloc.h"
+#include "gp_alloc.h"
 #include "set.h"
 }